#include "CIndice2.h"

CIndice2::CIndice2(void)	// Constructeur par dfaut
{
	*this = 0;
}

CIndice2::CIndice2(CIndice2 &i)	// Constructeur avec initialisation par CIndice2
{
	*this = i;
}

CIndice2::CIndice2(long a,long b)	// Constructeur avec initialisation par 2 entres
{
	this->ab[0] = a;
	this->ab[1] = b;
}

CIndice2::~CIndice2(void)	// Destructeur
{
	// Nothind todo
}

void CIndice2::swap(CIndice2 *i)	// Echange les 2 indices A et B avec un autre CIndice2
{
	CIndice2 tmp=*this;
	*this=*i;
	*i=tmp;
}

//////////////////////////////
//	Les oprateurs simples	//
//////////////////////////////

void CIndice2::operator = (CIndice2 &i)
{
	this->ab[0] = i.ab[0];
	this->ab[1] = i.ab[1];
}

void CIndice2::operator = (long i)
{
	this->ab[0] = i;
	this->ab[1] = i;
}

CIndice2 CIndice2::operator + (CIndice2 &i)
{
	return CIndice2(this->ab[0]+i.ab[0], this->ab[1]+i.ab[1]);
}

CIndice2 CIndice2::operator + (long i)
{
	return CIndice2(this->ab[0]+i, this->ab[1]+i);
}

CIndice2 CIndice2::operator - (CIndice2 &i)
{
	return CIndice2(this->ab[0]-i.ab[0], this->ab[1]-i.ab[1]);
}

CIndice2 CIndice2::operator - (long i)
{
	return CIndice2(this->ab[0]-i, this->ab[1]-i);
}

CIndice2 CIndice2::operator * (CIndice2 &i)
{
	return CIndice2(this->ab[0]*i.ab[0], this->ab[1]*i.ab[1]);
}

CIndice2 CIndice2::operator * (long i)
{
	return CIndice2(this->ab[0]*i, this->ab[1]*i);
}

CIndice2 CIndice2::operator / (CIndice2 &i)
{
	return CIndice2(this->ab[0]/i.ab[0], this->ab[1]/i.ab[1]);
}

CIndice2 CIndice2::operator / (long i)
{
	return CIndice2(this->ab[0]/i, this->ab[1]/i);
}

//////////////////////////////
//	Les oprateurs floats	//
//////////////////////////////

void CIndice2::operator += (CIndice2 &i)
{
	this->ab[0] += i.ab[0];
	this->ab[1] += i.ab[1];
}

void CIndice2::operator += (long i)
{
	this->ab[0] += i;
	this->ab[1] += i;
}

void CIndice2::operator -= (CIndice2 &i)
{
	this->ab[0] -= i.ab[0];
	this->ab[1] -= i.ab[1];
}

void CIndice2::operator -= (long i)
{
	this->ab[0] -= i;
	this->ab[1] -= i;
}

void CIndice2::operator *= (CIndice2 &i)
{
	this->ab[0] *= i.ab[0];
	this->ab[1] *= i.ab[1];
}

void CIndice2::operator *= (long i)
{
	this->ab[0] *= i;
	this->ab[1] *= i;
}

void CIndice2::operator /= (CIndice2 &i)
{
	this->ab[0] /= i.ab[0];
	this->ab[1] /= i.ab[1];
}

void CIndice2::operator /= (long i)
{
	this->ab[0] /= i;
	this->ab[1] /= i;
}

//////////////////////////////
//	Les oprateurs de test	//
//////////////////////////////

bool CIndice2::operator == (CIndice2 &i)
{
	return ((this->ab[0]==i.ab[0])&&(this->ab[1]==i.ab[1]));
}

bool CIndice2::operator != (CIndice2 &i)
{
	return ((this->ab[0]!=i.ab[0])||(this->ab[1]!=i.ab[1]));
}
