#ifndef __HCIndice3__
#define __HCIndice3__

typedef struct
{
	long abc[3];
}SIndice3;

class CIndice3 {
public:
	long abc[3];

	CIndice3(void);	// Constructeur par dfaut
	CIndice3(CIndice3 &i);	// Constructeur avec initialisation par CIndice3
#ifdef __HCIndice2__
	CIndice3(CIndice2 &i,long c);	// Constructeur d'un CIndice3  partir d'un CIndice2 + indice C
	CIndice3(long c,CIndice2 &i);	// Constructeur d'un CIndice3  partir d'un indice C + CIndice2
#endif
	CIndice3(long a,long b,long c);	// Constructeur avec initialisation par 3 entres
	~CIndice3(void);	// Destructeur
	void swap(CIndice3 *i);	// Echange les 3 indices ABC avec un autre CIndice3

	void operator = (CIndice3 &i);
	void operator = (long i);
	CIndice3 operator + (CIndice3 &i);
	CIndice3 operator + (long i);
	CIndice3 operator - (CIndice3 &i);
	CIndice3 operator - (long i);
	CIndice3 operator * (CIndice3 &i);
	CIndice3 operator * (long i);
	CIndice3 operator / (CIndice3 &i);
	CIndice3 operator / (long i);

	void operator += (CIndice3 &i);
	void operator += (long i);
	void operator -= (CIndice3 &i);
	void operator -= (long i);
	void operator *= (CIndice3 &i);
	void operator *= (long i);
	void operator /= (CIndice3 &i);
	void operator /= (long i);

	bool operator == (CIndice3 &i);
	bool operator != (CIndice3 &i);

	operator const long *() const { return abc; }
	long &operator[](unsigned int index){ return *(((long *) abc) + index); }
};

#endif // __HCIndice3__
