#ifndef __HCIndice4__
#define __HCIndice4__

typedef struct
{
	long abc[3];
}SIndice4;

class CIndice4 {
public:
	long abcd[4];

	CIndice4(void);	// Constructeur par dfaut
	CIndice4(CIndice4 &i);	// Constructeur avec initialisation par CIndice4
#ifdef __HCIndice2__
	CIndice4(CIndice2 &i,long c,long d);	// Constructeur d'un CIndice4  partir d'un CIndice2 + indice C et D
#endif
#ifdef __HCIndice3__
	CIndice4(CIndice3 &i,long d);	// Constructeur d'un CIndice4  partir d'un CIndice3 + indice D
#endif
	CIndice4(long a,long b,long c,long d);	// Constructeur avec initialisation par 4 entres
	~CIndice4(void);	// Destructeur
	void swap(CIndice4 *i);	// Echange les 4 indices ABCD avec un autre CIndice4

	void operator = (CIndice4 &i);
	void operator = (long i);
	CIndice4 operator + (CIndice4 &i);
	CIndice4 operator + (long i);
	CIndice4 operator - (CIndice4 &i);
	CIndice4 operator - (long i);
	CIndice4 operator * (CIndice4 &i);
	CIndice4 operator * (long i);
	CIndice4 operator / (CIndice4 &i);
	CIndice4 operator / (long i);

	void operator += (CIndice4 &i);
	void operator += (long i);
	void operator -= (CIndice4 &i);
	void operator -= (long i);
	void operator *= (CIndice4 &i);
	void operator *= (long i);
	void operator /= (CIndice4 &i);
	void operator /= (long i);

	bool operator == (CIndice4 &i);
	bool operator != (CIndice4 &i);

	operator const long *() const { return abcd; }
	long &operator[](unsigned int index){ return *(((long *) abcd) + index); }
};

#endif // __HCIndice4__
