#ifndef __HCIndice2__
#define __HCIndice2__

typedef struct
{
	long ab[2];
}SIndice2;

class CIndice2 {
public:
	long ab[2];

	CIndice2(void);	// Constructeur par dfaut
	CIndice2(CIndice2 &i);	// Constructeur avec initialisation par CIndice2
	CIndice2(long a,long b);	// Constructeur avec initialisation par 2 entres
	~CIndice2(void);	// Destructeur
	void swap(CIndice2 *i);	// Echange les 2 indices AB avec un autre CIndice2

	void operator = (CIndice2 &i);
	void operator = (long i);
	CIndice2 operator + (CIndice2 &i);
	CIndice2 operator + (long i);
	CIndice2 operator - (CIndice2 &i);
	CIndice2 operator - (long i);
	CIndice2 operator * (CIndice2 &i);
	CIndice2 operator * (long i);
	CIndice2 operator / (CIndice2 &i);
	CIndice2 operator / (long i);

	void operator += (CIndice2 &i);
	void operator += (long i);
	void operator -= (CIndice2 &i);
	void operator -= (long i);
	void operator *= (CIndice2 &i);
	void operator *= (long i);
	void operator /= (CIndice2 &i);
	void operator /= (long i);

	bool operator == (CIndice2 &i);
	bool operator != (CIndice2 &i);

	operator const long *() const { return ab; }
	long &operator[](unsigned int index){ return *(((long *) ab) + index); }
};

#endif // __HCIndice2__
